name: Build & Staging
on:
  push:
    branches:
      - develop

env:
  CONTAINER_REGISTRY: ghcr.io
  CONTAINER_REGISTRY_USER: ${{ secrets.GHCR_CONTAINER_REGISTRY_USER }}
  CONTAINER_REGISTRY_PASSWORD: ${{ secrets.GHCR_TOKEN }}
  CONTAINER_REGISTRY_REPO: ghcr.io/city-of-helsinki/${{ github.event.repository.name }}
  REPO_NAME: ${{ github.event.repository.name }}
  KUBECONFIG_RAW: ${{ secrets.KUBECONFIG_RAW_STAGING }}
  BUILD_ARTIFACT_FOLDER: 'build_artifacts'
  SERVICE_ARTIFACT_FOLDER: 'service_artifacts'
  BASE_DOMAIN: ${{ secrets.BASE_DOMAIN_STAGING }}
  SERVICE_PORT: 80

jobs:
  build:
    runs-on: ubuntu-latest
    name: Build
    steps:
      - uses: actions/checkout@v2
      - name: Build
        uses: andersinno/kolga-build-action@v2
        env:
          DOCKER_IMAGE_NAME: ${{ env.REPO_NAME }}-staging
          DOCKER_BUILD_ARG_REACT_APP_ENVIRONMENT: 'staging'
          DOCKER_BUILD_ARG_REACT_APP_PROFILE_LINK: "https://profiili.${{ env.BASE_DOMAIN }}/loginsso"
          DOCKER_BUILD_ARG_REACT_APP_OIDC_AUTHORITY: "https://tunnistamo.${{ env.BASE_DOMAIN }}/"
          DOCKER_BUILD_ARG_REACT_APP_OIDC_CLIENT_ID: "https://api.hel.fi/auth/jassari"
          DOCKER_BUILD_ARG_REACT_APP_OIDC_SCOPE: "openid https://api.hel.fi/auth/jassariapi https://api.hel.fi/auth/helsinkiprofile"
          DOCKER_BUILD_ARG_REACT_APP_PROFILE_GRAPHQL: "https://jassari-federation.${{ env.BASE_DOMAIN }}/"
          DOCKER_BUILD_ARG_REACT_APP_BASE_URL: "https://jassari.${{ env.BASE_DOMAIN }}"
          DOCKER_BUILD_ARG_REACT_APP_ADMIN_URL: "https://jassari-admin.${{ env.BASE_DOMAIN }}/"

  staging:
    runs-on: ubuntu-latest
    needs: build
    name: Staging
    steps:
      - uses: actions/checkout@v2
      - uses: andersinno/kolga-setup-action@v2

      - name: Deploy
        uses: andersinno/kolga-deploy-action@v2
        with:
          track: 'staging'
        env:
          K8S_NAMESPACE: ${{ secrets.K8S_NAMESPACE_STAGING }}
          ENVIRONMENT_URL: https://${{ secrets.ENVIRONMENT_URL_STAGING }}
          DOCKER_IMAGE_NAME: ${{ env.REPO_NAME }}-staging
